import ModuleWithLifecycle from './ModuleWithLifecycle.mjs';
import { IModuleWithСonfig } from './IModule.types.mjs';
import '@lskjs/log';
import './IEventEmitter.types.mjs';

declare abstract class ModuleWithConfig extends ModuleWithLifecycle implements IModuleWithСonfig {
    config: {
        [key: string]: any;
    };
    /**
     * config from constructor
     */
    __config: {
        [key: string]: any;
    };
    setProp(key: string, value: any): Promise<void>;
    getConfig(): Promise<Record<string, any>>;
    init(): Promise<void>;
}

export { ModuleWithConfig, ModuleWithConfig as default };
