import ModuleWithLog from './ModuleWithLog.mjs';
import { IEventEmitter } from './IEventEmitter.types.mjs';
import { IModuleWithEE } from './IModule.types.mjs';
import '@lskjs/log';
import './ModuleWithConfig.mjs';
import './ModuleWithLifecycle.mjs';

declare abstract class ModuleWithEE extends ModuleWithLog implements IModuleWithEE {
    ee?: IEventEmitter;
    createEe(): IEventEmitter;
    on(event: string, callback: (...args: any[]) => void): void;
    emit(event: string, ...args: any[]): void;
    init(): Promise<void>;
    __lifecycleEvent(name: string, value?: Date): Promise<void>;
}

export { ModuleWithEE, ModuleWithEE as default };
