import { IModuleWithLifecycle, IModuleLifecycle, IModule, IModuleConstructor, IModuleProps } from './IModule.types.mjs';
import '@lskjs/log';
import './IEventEmitter.types.mjs';

declare abstract class ModuleWithLifecycle implements IModuleWithLifecycle {
    name: string;
    __lifecycle: IModuleLifecycle;
    static new<T extends IModule>(this: IModuleConstructor<T>, ...propsArray: IModuleProps[]): T;
    static create<T extends IModule>(this: IModuleConstructor<T>, ...propsArray: IModuleProps[]): Promise<T>;
    static createAndRun<T extends IModule>(this: IModuleConstructor<T>, ...propsArray: IModuleProps[]): Promise<T>;
    static start<T extends IModule>(this: IModuleConstructor<T>, ...propsArray: IModuleProps[]): Promise<T>;
    setProp(key: string, value: any): void;
    setProps(...propsArray: IModuleProps[]): void;
    __lifecycleEvent(name: string, value?: Date): Promise<void>;
    onInit(): Promise<void>;
    __init(): Promise<void>;
    _init(): Promise<void>;
    init(): Promise<void>;
    start(): Promise<void>;
    __run(): Promise<void>;
    _run(): Promise<void>;
    run(): Promise<void>;
    __stop(): Promise<void>;
    _stop(): Promise<void>;
    stop(): Promise<void>;
}

export { ModuleWithLifecycle, ModuleWithLifecycle as default };
