import { ILogger } from '@lskjs/log';
import ModuleWithConfig from './ModuleWithConfig.mjs';
import { IModuleWithLog } from './IModule.types.mjs';
import './ModuleWithLifecycle.mjs';
import './IEventEmitter.types.mjs';

declare abstract class ModuleWithLog extends ModuleWithConfig implements IModuleWithLog {
    log: ILogger;
    debug?: boolean;
    createLog(): ILogger;
    init(): Promise<void>;
    run(): Promise<void>;
    stop(): Promise<void>;
    __lifecycleEvent(name: string, value?: Date): Promise<void>;
}

export { ModuleWithLog, ModuleWithLog as default };
