import ModuleWithEE from './ModuleWithEE.js';
import { IModuleWithSubmodules, IAsyncModuleKeyValue, IModuleKeyValue, IModule } from './IModule.types.js';
import './ModuleWithLog.js';
import '@lskjs/log';
import './ModuleWithConfig.js';
import './ModuleWithLifecycle.js';
import './IEventEmitter.types.js';

declare abstract class ModuleWithSubmodules extends ModuleWithEE implements IModuleWithSubmodules {
    __availableModules: IAsyncModuleKeyValue;
    __initedModules: IModuleKeyValue;
    __getModules(): Promise<IAsyncModuleKeyValue>;
    __parent?: IModule;
    modules?: IAsyncModuleKeyValue;
    mutexMap: {};
    getModules(): IAsyncModuleKeyValue;
    getModuleConfig(name: string): Promise<Record<string, unknown>>;
    getModuleProps(name: string): Promise<Record<string, unknown>>;
    hasModule(nameOrNames: string | string[]): boolean | {
        [name: string]: boolean;
    };
    moduleGetter(m: IModule): Promise<any>;
    module(nameOrNames: string | string[], { run: isRun, throw: throwIfNotFound, getter }?: {
        run?: boolean;
        throw?: boolean;
        getter?: any;
    }): Promise<IModule | IModuleKeyValue | null>;
    init(): Promise<void>;
    private __initModules;
    private __runModules;
    run(): Promise<void>;
}

export { ModuleWithSubmodules, ModuleWithSubmodules as default };
